//
// SleepWamp v1.01 (C) 1999 Mikael Klasson
// fluff@geocities.com
// http://mklasson.cjb.net
//
// This util lets you set a timer and when the timer runs out, Winamp gets killed.
// I've only tested it with Winamp v2.20 - v2.5c, but the classname is "Winamp v1.x", 
// so this util ought to be compatible with at least the 1.x versions. I rather doubt 
// they'll change the class name unless they do a major rewrite, so you're probably safe 
// for quite some time.
//
// Enjoy, this is Freeware.
//

#define	WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <shellapi.h>
#include <stdio.h>
#include "resource.h"

#define	snprintf		_snprintf

#define	TIMERID			42
#define	ICONID			303
#define	NOTIFYID		31416


int WINAPI		WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nShowCmd );
LRESULT CALLBACK	WindowProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam );


char		gaversion[] = "SleepWamp v1.01";
char		gaabout[] = "Coded by Mikael Klasson in 1999?\n"\
			    "fluff@geocities.com\n"\
			    "http://mklasson.cjb.net";

HWND		ghwnd = 0;

HICON		ghiempty = 0;
HICON		ghifull = 0;
HICON		ghierr = 0;

HMENU		ghmenu = 0;

int		gntimeleft = 0;		// Time left till winamp will be killed (in seconds. 0 means don't kill)
int		gnoldticks = 0;		// Tickcount when timer was set


void systray( DWORD dwmsg, HICON hi, char *ptip )
{
	NOTIFYICONDATA	nid;
	int		nsecs;

	memset( &nid, 0, sizeof( nid ) );
	nid.cbSize = sizeof( nid );
	snprintf( nid.szTip, sizeof( nid.szTip ), "SleepWamp" );
	if( hi ) {
		nid.hIcon = hi;
		snprintf( nid.szTip, sizeof( nid.szTip ), ptip );
	} else {
		if( !gntimeleft ) {
			nid.hIcon = ghiempty;
			snprintf( nid.szTip, sizeof( nid.szTip ), "SleepWamp - disabled" );
		} else {
			nid.hIcon = ghifull;
			nsecs = gntimeleft - 1 - ( GetTickCount() - gnoldticks ) / 1000;
			if( gntimeleft > 60 * 60 ) {
				snprintf( nid.szTip, sizeof( nid.szTip ), "SleepWamp - %d h, %d min, %d sec left", nsecs / 60 / 60, nsecs / 60 % 60, nsecs % 60 );
			} else if( gntimeleft > 60 ) {
				snprintf( nid.szTip, sizeof( nid.szTip ), "SleepWamp - %d min, %d sec left", nsecs / 60 % 60, nsecs % 60 );
			} else {
				snprintf( nid.szTip, sizeof( nid.szTip ), "SleepWamp - %d seconds left", nsecs );
			}
		}
	}
	if( !nid.hIcon ) {
		nid.hIcon = LoadIcon( NULL, IDI_APPLICATION );	// fallback icon
	}
	nid.hWnd = ghwnd;
	nid.uCallbackMessage = NOTIFYID;
	nid.uID = ICONID;
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;

	Shell_NotifyIcon( dwmsg, &nid );
}


// Returns:	TRUE if init ok
//		FALSE if error
int initwin( HINSTANCE hinst )
{
	WNDCLASS	wc;

	memset( &wc, 0, sizeof( wc ) );
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.hInstance = hinst;
	wc.hIcon = ghifull;
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = NULL;
	wc.lpszClassName = "SleepWamp";
	wc.lpszMenuName = "SleepWamp";
	if( !RegisterClass( &wc ) ) {
		return FALSE;
	}

	if( !( ghwnd = CreateWindow( "SleepWamp", "SleepWamp",
					WS_OVERLAPPEDWINDOW,
					0, 0,
					0, 0,
					NULL,
					NULL,
					hinst,
					NULL ) ) ) {
		return FALSE;
	}

	ShowWindow( ghwnd, SW_HIDE );
	UpdateWindow( ghwnd );

	return TRUE;
}


// Returns:	TRUE if init ok
//		FALSE if error
int initapp( HINSTANCE hinst )
{
	ghiempty = LoadIcon( hinst, MAKEINTRESOURCE( IDI_EMPTY ) );
	ghifull = LoadIcon( hinst, MAKEINTRESOURCE( IDI_FULL ) );
	ghierr = LoadIcon( hinst, MAKEINTRESOURCE( IDI_ERR ) );

	if( !initwin( hinst ) ) {
		return FALSE;
	}

	ghmenu = LoadMenu( hinst, MAKEINTRESOURCE( IDR_MENU ) );

	systray( NIM_ADD, NULL, NULL );

	return TRUE;
}


// Sets a timer that will kill winamp when triggered
void sleepset( int nsecs )
{
	gntimeleft = nsecs;

	KillTimer( ghwnd, TIMERID );

	if( nsecs ) {
		SetTimer( ghwnd, TIMERID, nsecs * 1000, NULL );
	}
	systray( NIM_MODIFY, NULL, NULL );

	gnoldticks = GetTickCount();
}


void killwinamp( void )
{
	HWND	hwnd;

	if( ( hwnd = FindWindowEx( NULL, NULL, "Winamp v1.x", NULL ) ) ) {
		SendMessage( hwnd, WM_SYSCOMMAND, SC_CLOSE, 0 );
	} else {
		systray( NIM_MODIFY, ghierr, "SleepWamp - Error trying to kill Winamp!" );
	}
}


LRESULT CALLBACK WindowProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam )
{
	POINT	pt;

	switch( umsg ) {
		case WM_DESTROY:
			PostQuitMessage( 0 );
			return FALSE;

		case WM_TIMER:
			switch( wparam ) {
				case TIMERID:
					sleepset( 0 );
					killwinamp();
					break;
			}
			return FALSE;

		case NOTIFYID:
			switch( LOWORD( lparam ) ) {
				case WM_MOUSEMOVE:
					systray( NIM_MODIFY, NULL, NULL );
					break;

				case WM_RBUTTONUP:
					GetCursorPos( &pt );
					TrackPopupMenu( GetSubMenu( ghmenu, 0 ), TPM_LEFTALIGN | TPM_TOPALIGN, pt.x, pt.y, 0, ghwnd, NULL );
					break;
			}
			return FALSE;

		case WM_COMMAND:
			switch( wparam ) {
				case ID_MAIN_DISABLE:
					sleepset( 0 );
					return FALSE;

				case ID_MAIN_6H:
					sleepset( 6 * 60 * 60 );
					return FALSE;

				case ID_MAIN_5H:
					sleepset( 5 * 60 * 60 );
					return FALSE;

				case ID_MAIN_4H:
					sleepset( 4 * 60 * 60 );
					return FALSE;

				case ID_MAIN_3H:
					sleepset( 3 * 60 * 60 );
					return FALSE;

				case ID_MAIN_2H:
					sleepset( 2 * 60 * 60 );
					return FALSE;

				case ID_MAIN_1H:
					sleepset( 1 * 60 * 60 );
					return FALSE;

				case ID_MAIN_45MIN:
					sleepset( 45 * 60 );
					return FALSE;

				case ID_MAIN_30MIN:
					sleepset( 30 * 60 );
					return FALSE;

				case ID_MAIN_15MIN:
					sleepset( 15 * 60 );
					return FALSE;
				
				case ID_MAIN_5MIN:
					sleepset( 5 * 60 );
					return FALSE;

				case ID_MAIN_ABOUT:
					if( MessageBox( NULL, gaabout, gaversion, MB_YESNO | MB_ICONINFORMATION ) == IDNO ) {
						MessageBox( NULL, "Wrong.", gaversion, MB_OK );
					}
					return FALSE;

				case ID_MAIN_QUIT:
					PostQuitMessage( 0 );
					return FALSE;
			}
			break;
	}

	return DefWindowProc( hwnd, umsg, wparam, lparam );
}


int WINAPI WinMain( HINSTANCE hinst, HINSTANCE hprevinst, LPSTR lpcmdline, int nshowcmd )
{
	MSG		msg;

	if( !initapp( hinst ) ) {
		return 0;
	}

	while( TRUE ) {
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			if( !GetMessage( &msg, NULL, 0, 0 ) ) {
				break;
			}
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		} else {
			WaitMessage();
		}
	}

	DestroyMenu( ghmenu );
	systray( NIM_DELETE, NULL, NULL );
	KillTimer( ghwnd, TIMERID );

	return msg.wParam;
}

